"{ Package: 'stx:goodies/newcompiler' }"

LibraryDefinition subclass:#stx_goodies_newcompiler
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_newcompiler class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:goodies/libtool3'    "Tools::Inspector2Tab - referenced by IRFunction>>inspector2TabIRCode "
        #'stx:goodies/refactoryBrowser/parser'    "RBIdentifierToken - referenced by IRDecompiler>>newVar: "
        #'stx:goodies/sunit'    "TestCase - superclass of IRTransformTest "
        #'stx:libbasic'    "Link - superclass of IRLine "
        #'stx:libbasic2'    "OrderedDictionary - referenced by IRBytecodeGenerator>>initialize "
        #'stx:libcomp'    "PrimitiveNode - referenced by IRFunction>>initialize "
        #'stx:libcompat'    "Preferences - referenced by IRDecompiler>>removeClosureCreation: "
        #'stx:libwidg'    "ScrollableView - referenced by IRFunction>>inspector2TabIRCode "
    )
! !

!stx_goodies_newcompiler class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        IRBuilder
        IRBuilderTest
        IRBytecodeGenerator
        IRFunction
        IRInstruction
        IRInterpreter
        IRSequence
        IRStackCount
        IRTransformTest
        #'stx_goodies_newcompiler'
        IRAccess
        IRClosure
        IRConstant
        IRDecompiler
        IRDup
        IRJump
        IRLine
        IRMethod
        IRPop
        IRPrinter
        IRReturn
        IRSend
        IRTranslator
        IRBlockReturnTop
        IRInstVarAccess
        IRJumpIf
        IRJumpOverBlock
        IRLiteralVariableAccess
        IRTempAccess
        IRInstVarRead
        IRInstVarStore
        IRLiteralVariableRead
        IRLiteralVariableStore
        IRTempRead
        IRTempStore
    )
!

extensionMethodNames
    ^ #(
        ByteCodeCompiler literalArray:
        Class binding
        Class bindingOf:
    )
! !

!stx_goodies_newcompiler class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'CVUT FEI & Mathieu Suen'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Bytecode generation library based on Squeak''s NewCompiler'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Jan Vrany & Mathieu Suen 2008'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'NewCompiler'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!stx_goodies_newcompiler class methodsFor:'documentation'!

version
    ^'$Id$'
! !
